// Capster: http://apps.bcheck.net/
// apps@bcheck.net

// 2003-05-26: vastly simplified and shrunk
// 2007-12-11: similarize to reso

#include <windows.h>
#include <shlobj.h>
#include "resource.h"

#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='x86' publicKeyToken='6595b64144ccf1df' language='*'\"")

const char* g_szTitle = "Capster";
HINSTANCE g_hInst;
HWND g_hwnd;
char g_szCapsterPath[MAX_PATH];

void RunCapsterApp(char* cmdline);

void Warn(const char* szErr) {
	MessageBox(g_hwnd, szErr, g_szTitle, MB_ICONEXCLAMATION);
}

char* _tok;
char* mystrtok(char* sz, const char* seps) {
	const char* p;

	if(sz) _tok=sz;
	else sz=_tok;

	while(*_tok) {
		for(p=seps; *p; p++)
			if(*_tok==*p) {
				*_tok=0;
				_tok++;
				return sz;
			}
		_tok++;
	}
	if(sz==_tok)
		return NULL;
	else
		return sz;
}

int myatoi(const char* a) {
	int i=0,neg=1;
	if(!a) return 0;
	while(*a==' ') a++;
	if(*a=='-') {
		a++;
		neg=-1;
	}
	while(*a && *a>='0' && *a<='9')
		i = i*10 + *(a++)-'0';
	return i*neg;
}

HRESULT CreateStartupLink(const char* szShortcut,
	const char* szRunFile, const char* szArguments, const char* szWorkingDir, const char* szIconFile)
{
	HRESULT hres;
	IShellLink* psl;
	
	hres=OleInitialize(NULL);
	if(hres == S_FALSE || hres == S_OK) {
		
		hres = CoCreateInstance(&CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER,
			&IID_IShellLink, (void **) &psl);
		if(SUCCEEDED(hres)) {
			IPersistFile* ppf;
			
			hres = psl->lpVtbl->QueryInterface(psl, &IID_IPersistFile, (void **)&ppf);
			if(SUCCEEDED(hres)) {
				{
					hres = psl->lpVtbl->SetPath(psl, szRunFile);
					psl->lpVtbl->SetWorkingDirectory(psl, szWorkingDir);
					psl->lpVtbl->SetArguments(psl, szArguments);
					psl->lpVtbl->SetIconLocation(psl, szIconFile, 0);
				}
				if(SUCCEEDED(hres)) {
					WCHAR wsz[MAX_PATH];
					wsprintfW(wsz, L"%S", szShortcut);
					hres=ppf->lpVtbl->Save(ppf, (const WCHAR*)wsz, TRUE);
				}
				ppf->lpVtbl->Release(ppf);
			}
			psl->lpVtbl->Release(psl);
		}
		OleUninitialize();
	}
	return hres;
}

void InitDialog(HWND hdlg) {
	HWND hwndCaps = GetDlgItem(hdlg, IDC_CAPS);
	SendMessage(hwndCaps, CB_ADDSTRING, 0, (LPARAM)"off");
	SendMessage(hwndCaps, CB_ADDSTRING, 0, (LPARAM)"ON");
	SendMessage(hwndCaps, CB_SETCURSEL, (WPARAM)1, 0);

	// global hwnd
	g_hwnd = hdlg;
	SetClassLong(hdlg,GCL_HICON,(long)LoadIcon(g_hInst,MAKEINTRESOURCE(IDI_CAPSTER)) );
	{
		HMENU hMenu = GetSystemMenu(hdlg, FALSE);
		AppendMenu(hMenu, MF_SEPARATOR, 0, 0);
		AppendMenu(hMenu, MF_STRING, 123,  "About Capster...");
	}
}

// given szFile = "c:\pathname\stuff\application.exe"
// return NameStart = "application.exe"
//        ExtStart  = ".exe"
void CrackFilename(char* szFile, char** ppNameStart, char** ppExtStart) {
	char* NameStart, *ExtStart;
	NameStart = strrchr(szFile, '\\');
	if(!NameStart) NameStart = szFile;
	else NameStart++;
	if(ppExtStart) {
		ExtStart = strrchr(NameStart, '.');
		if(!ExtStart) ExtStart = NameStart+lstrlen(NameStart);
		*ppExtStart = ExtStart;
	}
	if(ppNameStart)
		*ppNameStart = NameStart;
}

BOOL GetAppToRun(char *szFile, DWORD ccbFile) {
	OPENFILENAME ofn;
	szFile[0]=0;

	/* Initialize OPENFILENAME struct */
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.lpstrFilter = "Programs (*.exe,*.com,*.bat)\0*.exe;*.com;*.bat\0All Files (*.*)\0*.*\0";
	ofn.nFilterIndex = 1;
	ofn.lpstrInitialDir = NULL; //"c:\\";
	ofn.lpstrFile = szFile;
	ofn.nMaxFile = ccbFile;
	ofn.lpstrTitle = "Select Application";
	ofn.Flags = OFN_HIDEREADONLY | OFN_PATHMUSTEXIST | OFN_EXPLORER | OFN_ENABLESIZING;
	ofn.lpstrDefExt = ofn.lpstrCustomFilter = ofn.lpstrFileTitle = NULL;
	ofn.hwndOwner = g_hwnd;
	ofn.hInstance = g_hInst;

	/* Display the Open dialog box */
	return GetOpenFileName(&ofn);
}

void queryShellFolders(char *name, char *out) {
	HKEY hKey;
	if ( RegOpenKeyEx(HKEY_CURRENT_USER,"Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders",0,KEY_READ,&hKey) == ERROR_SUCCESS) {
		int l = MAX_PATH;
		int t = REG_SZ;
		RegQueryValueEx(hKey,name,NULL,&t,out,&l );
		RegCloseKey(hKey);
	}
}

/* ask user for location to save shortcut */
BOOL GetSaveLocation(char* szFile, int cbszFile) {
	OPENFILENAME ofn;

	/* Initialize OPENFILENAME struct */
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.lpstrFilter = "Shortcut File (*.lnk)\0*.lnk\0All Files (*.*)\0*.*\0";
	ofn.nFilterIndex = 1;
	ofn.lpstrInitialDir = NULL; //"c:\\";
	ofn.lpstrFile = szFile;
	ofn.nMaxFile = cbszFile;
	ofn.lpstrTitle = "Create Shortcut";
	ofn.Flags = OFN_HIDEREADONLY | OFN_EXPLORER | OFN_ENABLESIZING;
	ofn.lpstrDefExt = ofn.lpstrCustomFilter = ofn.lpstrFileTitle = NULL;
	ofn.hwndOwner = g_hwnd;
	ofn.hInstance = g_hInst;

	/* Display the Save dialog box */
	return GetSaveFileName(&ofn);
}

void GetUserOptionsAsString(HWND hdlg, char* szArguments, char* runApplication, int* capsState)
{
	HWND hwndCaps = GetDlgItem(hdlg, IDC_CAPS);
	*capsState = SendMessage(hwndCaps, CB_GETCURSEL, 0, 0);

	GetDlgItemText(hdlg, IDC_APPLICATION, runApplication, MAX_PATH);

	wsprintf(szArguments, "\"%s\" %d", runApplication, *capsState);
}

UINT APIENTRY DialogProc(HWND hdlg, UINT uiMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uiMsg)
	{
	case WM_INITDIALOG:
		InitDialog(hdlg);
		return FALSE;
	case WM_CLOSE:
		EndDialog(hdlg,0);
		return TRUE;
	case WM_SYSCOMMAND:
		if(wParam == 123) {
			MessageBox(hdlg, "Capster (build 2)\r\nby Tim Rice\r\n\r\nAngelDust Research ltd.",
				"About Capster...", MB_ICONINFORMATION | MB_RIGHT);
			return TRUE;
		}
		return FALSE;
	case WM_COMMAND:
		if(wParam==IDCANCEL) {
			EndDialog(hdlg,0);
			return TRUE;
		} else if(wParam==IDC_BROWSE) {
			char szFile[MAX_PATH];
			if(GetAppToRun(szFile, sizeof(szFile)))
			{
				SetDlgItemText(hdlg, IDC_APPLICATION, szFile);
			}
			return TRUE;
		} else if(wParam==IDC_CREATESHORTCUT) {
			/* get user options */
			char szArguments[MAX_PATH], runApplication[MAX_PATH];
			int capsState = 1;
			GetUserOptionsAsString(hdlg, szArguments, runApplication, &capsState);

			/* make sure application exists */
			{
				DWORD attr = GetFileAttributes(runApplication);
				if(attr==INVALID_FILE_ATTRIBUTES || attr&FILE_ATTRIBUTE_DIRECTORY || attr&FILE_ATTRIBUTE_DEVICE) {
					Warn("Please select a valid application first.");
					return TRUE;
				}
			}

			/* create shortcut */
			{
				char szShortcut[MAX_PATH];
				char *nameStart, *extStart;

				/* create default shortcut name */
				CrackFilename(runApplication, &nameStart, &extStart);
				queryShellFolders("Startup", szShortcut);
				lstrcat(szShortcut, nameStart-1);
				wsprintf(&szShortcut[lstrlen(szShortcut)-lstrlen(extStart)], " (caps o%s).lnk", (capsState?"n":"ff") );

				/* ask user where to save shortcut */
				if(GetSaveLocation(szShortcut, sizeof(szShortcut))==TRUE) {
					BOOL bSuccess;

					/* setup capster arguments for application to run and display mode */
					char szWorkingDir[MAX_PATH];
					lstrcpy(szWorkingDir, runApplication);
					szWorkingDir[nameStart-runApplication]=0;

					/* create the shortcut */
					bSuccess = SUCCEEDED(CreateStartupLink(szShortcut, g_szCapsterPath, szArguments, szWorkingDir, runApplication));
					MessageBox(g_hwnd, (bSuccess ? "Shortcut created." : "Unable to create shortcut"),
						g_szTitle, (bSuccess ? MB_ICONINFORMATION : MB_ICONEXCLAMATION) );
				}
			}		
			return TRUE;
		}
	}
	return FALSE;
}

void Run(const char* szProgram, const char* szArguments, int nCmdShow)
{
	SHELLEXECUTEINFO sei;
	sei.cbSize = sizeof(SHELLEXECUTEINFO);
	sei.fMask = SEE_MASK_NOCLOSEPROCESS;
	sei.lpFile = szProgram;
	sei.lpParameters = szArguments;
	sei.nShow = nCmdShow;
	sei.hwnd = NULL;
	sei.lpVerb = sei.lpDirectory = NULL;
	// ShellExecuteEx outputs to hInstApp and hProcess members of sei structure

	// start the program "szProgram"
	if(!ShellExecuteEx(&sei))
	{
		Warn("Capster Error:\n\nError starting application");
	}
}

/* truncate and return next quotable string in cmdline, note cmdline is changed */
char* GetNextQuotedString(char* cmdline, char** quotedString) {
	if (*cmdline == '\"') {
		cmdline++;
		*quotedString = cmdline; /* save for setup */
		while (*cmdline && *cmdline != '\"') cmdline++;
		if (*cmdline) {
			*cmdline=0; /* replace closing quote with trunc */
			cmdline++;
		}
	} else {
		*quotedString = cmdline; /* save for setup */
		while (*cmdline && *cmdline != ' ') cmdline++;
		if (*cmdline) {
			*cmdline=0; /* replace space with trunc */
			cmdline++;
		}
	}
	while (*cmdline == ' ') cmdline++;
	return cmdline;
}

/* cmdline here is actually:
"APPTORUN.EXE" [1|0]
1 = run when caps lock on, 0 = run when caps lock off
*/
void RunCapsterApp(char* cmdline) {
	int capsState = 1;
	char *nextArgument; /* argument iterator */
	char *extraArguments = NULL; /* extra command line arguments, pass these on */
	char* szRunApp;

	/* get program to run */
	cmdline = GetNextQuotedString(cmdline, &szRunApp);

	/* get settings off command line */
	nextArgument = mystrtok(cmdline, " ");
	if(nextArgument) {
		capsState = myatoi(nextArgument);
		extraArguments = _tok;
	}

	/* run program if caps is appropriate */
	if( (capsState && GetKeyState(VK_CAPITAL)) ||
		(!capsState && !GetKeyState(VK_CAPITAL)) )
	{
		STARTUPINFO si;
		GetStartupInfo(&si); /* use properties of my shortcut to start selected app */

		if(capsState)
		{
			/* turn off caps lock */
			keybd_event( VK_CAPITAL, 0x45, KEYEVENTF_EXTENDEDKEY | 0, 0);
			keybd_event( VK_CAPITAL, 0x45, KEYEVENTF_EXTENDEDKEY | KEYEVENTF_KEYUP, 0);
		}

		Run(szRunApp, extraArguments, si.wShowWindow);
	}
}

/* note WinMain arguments are invalid if no CRT */
int WINAPI WinMain(HINSTANCE hInstanceNOUSE, HINSTANCE hPrevInstanceNOUSE,
				   LPSTR cmdlineNOUSE, int nCmdShowNOUSE) {
	char *cmdline, *szCapsterPath;
	g_hInst = GetModuleHandle(NULL);
	cmdline = GetCommandLine();

	/* get path to current running Capster (for making shortcuts) */
	cmdline = GetNextQuotedString(cmdline, &szCapsterPath);
	lstrcpy(g_szCapsterPath, szCapsterPath);

	/* run setup or run app */	
	if(*cmdline==0) {
		/* if there are no arguments, run Capster's setup */
		DialogBox(g_hInst, MAKEINTRESOURCE(IDD_DLG_CAPSTER), NULL, DialogProc);
	} else {
		/* otherwise run program */
		RunCapsterApp(cmdline);
	}

	ExitProcess(0); /* must explicitly call when no CRT */
}